#include <stdio.h>
#include <sql.h>
#include <sqlext.h>
#include <pthread.h>

#define CHUNKSIZE	65536
#define NUMTHREADS	20

pthread_mutex_t dataMutex = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t dataPresentCondition = PTHREAD_COND_INITIALIZER;

void *get_blob (SQLHDBC dbc)
{ 
  SQLHSTMT stmt;
  SQLRETURN ret; /* ODBC API return status */
  SQLCHAR table[ 65536 ];
  SQLLEN colsize2;
  int rc;
  int offset;
	
  rc = pthread_mutex_lock(&dataMutex);
  rc = pthread_cond_wait(&dataPresentCondition, &dataMutex);
  pthread_mutex_unlock(&dataMutex);
  
  /* Allocate a statement handle */
  SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

  ret = SQLExecDirect(stmt, "SELECT * FROM tblvoicemessages WHERE dir='/var/spool/asterisk/voicemail/K0001/6669/busy' AND msgnum='-1'", SQL_NTS);
   
  if (ret == SQL_SUCCESS) {
    printf("SQL_SUCCESS\n");
    ret = SQLFetch(stmt);
    printf("SQLFetch\n");
    
	if (ret == SQL_ERROR || ret == SQL_SUCCESS_WITH_INFO) {
      printf("error1: %d\n", ret);
    }
	
    if (ret == SQL_SUCCESS || ret == SQL_SUCCESS_WITH_INFO){
      printf( "Start SQLGetData\n");
	
	ret = SQLGetData(stmt, 11, SQL_BINARY, table, 0, &colsize2);
	
	  for (offset = 0; offset < colsize2; offset += CHUNKSIZE) {
	    ret = SQLGetData(stmt, 11, SQL_BINARY, table, CHUNKSIZE, NULL);
		sched_yield();
	  }
	  
      SQLFreeHandle (SQL_HANDLE_STMT, stmt);
    } else
      printf("error2 %d\n", ret);
	
  } else
    printf("error3: %d\n", ret);
	   
  return NULL;
}

main()
{
  SQLHENV env;
  SQLHDBC dbc;
  SQLHSTMT stmt;
  SQLRETURN ret; /* ODBC API return status */
  SQLSMALLINT columns; /* number of columns in result-set */
  SQLCHAR table[ 64 ];
  SQLCHAR column[ 64 ];
  long type;
  SQLLEN indicator[ 3 ];
  pthread_t thread[NUMTHREADS];
  int i,rc=0;;
  
  /* Allocate an environment handle */
  SQLAllocHandle(SQL_HANDLE_ENV, SQL_NULL_HANDLE, &env);

  /* We want ODBC 3 support */
  SQLSetEnvAttr(env, SQL_ATTR_ODBC_VERSION, (void *) SQL_OV_ODBC3, 0);

  /* Allocate a connection handle */
  SQLAllocHandle(SQL_HANDLE_DBC, env, &dbc);

  /* Connect to the DSN mydsn */
  /* You will need to change mydsn to one you have created and tested */
  SQLDriverConnect(dbc, NULL, "DSN=asteriskWrite;", SQL_NTS,
                NULL, 0, NULL, SQL_DRIVER_COMPLETE);
   

  for (i=0; i < NUMTHREADS; ++i) {
    rc = pthread_create(&thread[i], NULL, get_blob, dbc);
  }

  printf ("%d threads startet\n", NUMTHREADS);
 
  sleep(1);
  rc = pthread_cond_broadcast(&dataPresentCondition); /* wake up all */
   
  for (i=0; i < NUMTHREADS; ++i) {
    rc = pthread_join(thread[i], NULL);
  } 
}
